//#include <VirtuinoBluetooth.h>
//VirtuinoBluetooth virtuino(Serial3);

// D5 датчик температуры
// D6 зуммер
// D2 клапан воды
// D3 общее реле
// D запас
// А0 клавиатура
// А1 SCK весы
// А2 DT весы

//#include <LiquidCrystal.h>
#include "LiquidCrystal_1602_RUS.h"
#include <EEPROM.h>
#include <OneWire.h>
#include <HX711.h>
#include <Wire.h>
#include <iarduino_I2C_connect.h>                     // подключаем библиотеку для соединения arduino по шине I2C
iarduino_I2C_connect I2C2;                            // объявляем переменную для работы c библиотекой iarduino_I2C_connect

#define Relay 2// D2 реле
#define ObcheeRele 3// D3 реле центрального клапана
//#define YZO 26 //D26 узо
#define YZO 24 //D26 узо
#define YZOY 26 //D26 узо
#define Zumer 6// D6 пищалка
HX711 scale(A2, A1);// инициализация весов. Указываем в какие пины подключен АЦП hx711 (DT(DOUT)  - pin A2, SCK - pin A1)
byte OneWirePin = 5; // пин на котором датчики t

LiquidCrystal_1602_RUS lcd(42, 44, 46, 48, 50, 52);
///LiquidCrystal lcd(42, 44, 46, 48, 50, 52);// (RS, E, DB4, DB5, DB6, DB7)
//LiquidCrystal lcd(44, 42, 52, 50, 48, 46);// (RS, E, DB4, DB5, DB6, DB7)

byte addresa[20][8]; // 20 возможных датчиков хранятся локально
byte tochnost = 12; // может принимать только 9(0.5°C),10(0.25°C),11(0.125°C),12(0.0625°C)
OneWire ds (OneWirePin);
int kol = 0; // количество датчиков ( сканирование )
byte addr[8]; // адреса датчиков по запросу
float temp;
byte  REG_Massive[6];
int symma = 0;
int symmasymma = 0;
unsigned long otsutDatT = 0;//таймер отсутствия сигнала от датчика температуры
unsigned long previousMillis = 0; // таймер для борьбы с дребезгом кнопок
unsigned long TimeTrevoga = 0;//таймер отсутствия сигнала от датчика температуры
unsigned long vesMillis = 0; // таймер для весов
unsigned long Tok_Millis = 0; // таймер работает при режиме разгон
unsigned long serial_Time = 0;//таймер для отправки значений через serial
unsigned long trev_temp = 0; // таймер для весов
unsigned long trev_Tok = 0; // таймер для тэна
unsigned long Otkrit_Millis = 0; // таймер для весов
unsigned long Zakrit_Millis = 0; // таймер для весов
unsigned long time3 = 0;
int Ekran = 0;
int Pezhim_ekran = 0;
int TSensorOff = 0;//коэф отсутствия дат t
int Trev_ves = 0; //коэф превышен вес
int Trevoga_tok = 0;
int Koef_Sen_Off = 0;//коэф отсутствия дат t
int Tamer_Kei = 350; //таймер нажатия кнопки
float tempSensor[3];  // массив с показаниям датчика t
float tempSen0;  // массив с показаниям датчика t
float tempSen1;  // массив с показаниям датчика t
float tempSen2;  // массив с показаниям датчика t

float sensor[3];// массив с показаниям датчика t
float tempDelta = 0; // массив для установки дельты t
byte KEY; // значение нажатой кнопки
int button = 0; // флаг нажатия кнопки
int vestelo; // максимальный вес
float vesves;//значение веса на весах
int vestelo_eepro;//значение веса на весах
int Obiem;// значение объема
int Obiem_Real;
int menuLevel = 0;
int rezshim = 0;
int realI = 0; // получаемое от ардуино МИНИ значение реального тока
int fakt_I = 0;// полученное значение тока
int tok = 0; // ток
int Wtrazgon; // мощность разгона хранится в EEPROM
int WtOtbor;
int stat = 0; //флаг тревоги
int stat_razgon = 0; //флаг  разгон
int Max_t_kyb = 0;
int Max_t_Def = 0;
int Max_t_Carga = 0;
int Razg_t_kyb = 0;
int Razg_t_Def = 0;
int Razg_t_Carga = 0;
int pip = 0; //коэф тревога
int klapan_Otkrit = 0;
int klapan_Zakrit = 0;
int klapan = 0;
float total_W = 0;
float total_W_eeprom = 0;
unsigned long work_timer_buffer = 0;
int WWW = 0;
int WWW_time = 0;
long WWW_symma = 0;
int t_kyb_poddershka = 0;
int t_Def_poddershka = 0;
int t_Carga_poddershka = 0;
int koef = 0;
float otbor = 0;
int ves_Raznica = 0;
float otborfakt = 0;
float e = 1;
int stat_KVO = 0;
int beepOtkl = 0;
int beepOtkl_knopk = 0;
float soprotivlenie = 0;
int shetchik = 0; // счетчик для режима тревоги
int jjjj = 0;

void readSet() { // считываем EEPROM по сохраненной температуре и мощности
  EEPROM.get(0, tempDelta);
  EEPROM.get(5, vestelo);
  EEPROM.get(10, Wtrazgon);
  EEPROM.get(15, WtOtbor);
  EEPROM.get (20, Max_t_kyb);
  EEPROM.get (25, Max_t_Def);
  EEPROM.get (30, rezshim);
  EEPROM.get (35, stat);
  // EEPROM.get (40, otbor);
  EEPROM.get (45, Max_t_Carga);
  EEPROM.get(50, Razg_t_kyb);
  EEPROM.get(55, Razg_t_Def);
  EEPROM.get(60, Razg_t_Carga);
  EEPROM.get (65, klapan_Otkrit);
  EEPROM.get (70, klapan_Zakrit);
  EEPROM.get (75, t_kyb_poddershka);
  EEPROM.get (80, t_Def_poddershka);
  EEPROM.get (85, t_Carga_poddershka);
  EEPROM.get (90, time3);
  EEPROM.get (95,   tempSen0);
  EEPROM.get (100,   tempSen1);
  EEPROM.get (105, tempSen2);
  EEPROM.get (110, vestelo_eepro);
  EEPROM.get (115, total_W_eeprom);
  EEPROM.get (120, beepOtkl);
  EEPROM.get (125, beepOtkl_knopk);
  EEPROM.get (130, soprotivlenie);


  //если из еепром каляки баляки то изменяем значение на 0
  if (isnan(tempDelta)) {
    tempDelta = 70;
    EEPROM.put(0, tempDelta);
  }
  if (isnan(vestelo)) {
    vestelo = 0;
    EEPROM.put(5, vestelo);
  }
  if (isnan(Wtrazgon)) {
    Wtrazgon = 1000;
    EEPROM.put(10, Wtrazgon);
  }
  if (isnan(WtOtbor)) {
    WtOtbor = 1000;
    EEPROM.put(15, WtOtbor);
  }
  if (isnan(Max_t_kyb)) {
    Max_t_kyb = 0;
    EEPROM.put(20, Max_t_kyb);
  }
  if (isnan(Max_t_Def)) {
    Max_t_Def = 0;
    EEPROM.put(25, Max_t_Def);
  }
  if (isnan(rezshim)) {
    rezshim = 0;
    EEPROM.put(30, rezshim);
  }
  if (isnan(stat)) {
    stat = 0;
    EEPROM.put(35, stat);
  }
  //  if (isnan(otbor)) {
  //    otbor = 0;
  //    EEPROM.put(40, otbor);
  //  }
  if (isnan(Max_t_Carga)) {
    Max_t_Carga = 0;
    EEPROM.put(45, Max_t_Carga);
  }
  if (isnan(Razg_t_kyb)) {
    Razg_t_kyb = 0;
    EEPROM.put(50, Razg_t_kyb);
  }
  if (isnan(Razg_t_Def)) {
    Razg_t_Def = 0;
    EEPROM.put(55, Razg_t_Def);
  }
  if (isnan(Razg_t_Carga)) {
    Razg_t_Carga = 0;
    EEPROM.put(60, Razg_t_Carga);
  }
  if (isnan(klapan_Otkrit)) {
    klapan_Otkrit = 0;
    EEPROM.put(65, klapan_Otkrit);
  }
  if (isnan(klapan_Zakrit)) {
    klapan_Zakrit = 0;
    EEPROM.put(70, klapan_Zakrit);
  }
  if (isnan(t_kyb_poddershka)) {
    t_kyb_poddershka = 0;
    EEPROM.put(75, t_kyb_poddershka);
  }
  if (isnan(t_Def_poddershka)) {
    t_Def_poddershka = 0;
    EEPROM.put(80, t_Def_poddershka);
  }
  if (isnan(t_Carga_poddershka)) {
    t_Carga_poddershka = 0;
    EEPROM.put(85, t_Carga_poddershka);
  }
  if (isnan(time3)) {
    time3 = 0;
    EEPROM.put(90, time3);
  }
  if (isnan(tempSen0)) {
    tempSen0 = 0;
    EEPROM.put(95, tempSen0);
  }
  if (isnan(tempSen1)) {
    tempSen1 = 0;
    EEPROM.put(100, tempSen1);
  }
  if (isnan(tempSen2)) {
    tempSen2 = 0;
    EEPROM.put(105, tempSen2);
  }
  if (isnan(vestelo_eepro)) {
    vestelo_eepro = 0;
    EEPROM.put(110, vestelo_eepro);
  }
  if (isnan(total_W_eeprom)) {
    total_W_eeprom = 0;
    EEPROM.put(115, total_W_eeprom);
  }
  if (isnan(beepOtkl)) {
    beepOtkl = 0;
    EEPROM.put(120, beepOtkl);
  }
  if (isnan(beepOtkl_knopk)) {
    beepOtkl_knopk = 0;
    EEPROM.put(125, beepOtkl_knopk);
  }
  if (isnan(soprotivlenie)) {
    soprotivlenie = 0;
    EEPROM.put(130, soprotivlenie);
  }

}

void toch ()
{
  for (byte i = 0; i < 3; i++)
  {
    ds.reset();
    ds.select(addresa[i]); // выбираем датчик
    ds.write(0x4E);  // команда на запись в датчик
    ds.write(0x4B); // верх и низ для аварийных температур
    ds.write(0x46); // верх и низ для аварийных температур
    if (tochnost == 9) ds.write(0x00); // это разрядность конвертации
    if (tochnost == 10) ds.write(0x20); // это разрядность конвертации
    if (tochnost == 11) ds.write(0x40); // это разрядность конвертации
    if (tochnost == 12)  ds.write(0x60); // это разрядность конвертации
  }
  ds.reset();
  ds.write(0xCC); //Обращение ко всем датчикам
  ds.write(0x48); // переносим из оперативки датчика в EEPROM датчика
}
/////////////отправляем все датчики сети на расчет температуры//////////////////////////////////
void otpravNaRasch()
{
  ds.reset();     // Сбрасываем линию
  ds.write(0xCC); //Обращение ко всем датчикам
  ds.write(0x44); // Пишем 0x44 - команда на расчет температуры, паразитное питание не допустимо
}
///////////////выясняем сколько у нас датчиков на пине OneWirePin и заносим их адреса в массив//////////////
void kolDatch()
{
  kol = 0;
  while ( ds.search(addr))
  {
    for (byte i = 0; i < 8; i++) {
      addresa[kol][i] = addr[i];
    }
    kol = kol + 1;
  }
  ds.reset_search();
}
// ////////////////////  расчет температуры ///////////////////////
void tempa (byte u)
{
  ds.reset();
  ds.select(addresa[u]);
  ds.write(0xBE);              // Команда датчику, чтобы он начал отдавать данные.
  temp = (ds.read() | ds.read() << 8); //так и не понял как оно там считается, главное работает
  temp = (float)temp / 16.00;
  sensor[u] = temp;//______________________________________________________________________________

  //  tempSensor[0] = sensor[2];//царга
  //  tempSensor[1] = sensor[0];//деф
  //  tempSensor[2] = sensor[1];//куб

  tempSensor[0] = sensor[1];//царга
  tempSensor[1] = sensor[2];//деф
  tempSensor[2] = sensor[0];//куб
}

//void Grafik() {
//  //передадим значения для составления графиков
//  Serial.print (tempSensor[0], 1);
//  Serial.print (";");
//  Serial.print (tempSensor[1], 1);
//  Serial.print (";");
//  Serial.print (tempSensor[2], 1);
//  Serial.print (";");
//  Serial.print (fakt_I);
//  Serial.print (";");
//  if (digitalRead(Relay) == HIGH) Serial.println (1);//отметка включенного клапана
//  if (digitalRead(Relay) == LOW)  Serial.println (0);
//}

void Blupyp() {
  //  передаем значения для блютуза
  Serial3.print("t VKL klap");
  Serial3.println(tempDelta, 1);
  Serial3.print("t kolon      ");
  Serial3.println(tempSensor[0], 1);
  Serial3.print("t def          ");
  Serial3.println(tempSensor[1], 1);
  Serial3.print("t kyb          ");
  Serial3.println(tempSensor[2], 1);
  Serial3.print("Moch        ");
  Serial3.print(fakt_I);
  Serial3.println("Wt");
  Serial3.print("ob'em       ");
  Serial3.println(Obiem);
  if (digitalRead(Relay) == HIGH) Serial3.println ("Klap1-BKL");//отметка включенного клапана
  if (digitalRead(Relay) == LOW)  Serial3.println ("Klap1-OTKL");
  if (digitalRead(ObcheeRele) == HIGH) Serial3.println ("Klap2-BKL");//отметка включенного клапана
  if (digitalRead(ObcheeRele) == LOW)  Serial3.println ("Klap2-OTKL");
  if (stat == 2) Serial3.println ("tDef");
  if (stat == 3) Serial3.println ("tKyb");
  if (stat == 4) Serial3.println ("Vesy");
  if (stat == 5) Serial3.println ("tDat");
  if (stat == 6) Serial3.println ("tCar");
  if (stat == 8) Serial3.println ("Ten");
  //  Serial3.println("   ");
  //    // Передаем значения в Virtuino
  //  virtuino.vMemoryWrite(0, fakt_I);
  //  virtuino.vMemoryWrite(1, tempSensor[2]);
  //  virtuino.vMemoryWrite(2, tempSensor[0]);
  // // virtuino.vMemoryWrite(3, tempSensor[3]);
  //  virtuino.vMemoryWrite(4, tempSensor[1]);
  //  virtuino.vMemoryWrite(5, Obiem);
  //  virtuino.vMemoryWrite(6, tempDelta-tempSensor[0]);
  //  //virtuino.vMemoryWrite(7, tempDelta);
}
void Otkl () {
  tempSen0 = tempSensor[0];
  tempSen1 = tempSensor[1];
  tempSen2 = tempSensor[2];
  vestelo_eepro = Obiem;
  time3 = millis() / 1000;
  total_W_eeprom = total_W;
  EEPROM.put (90, time3);
  EEPROM.put (95, tempSen0);
  EEPROM.put (100, tempSen1);
  EEPROM.put (105, tempSen2);
  EEPROM.put (110, vestelo_eepro);
  EEPROM.put (115, total_W_eeprom);
  EEPROM.put(35, stat);
  delay (100);
  digitalWrite(YZO, HIGH); // через 3*4=12 сек откл из-за превышения мощности
  digitalWrite(YZOY, HIGH);
  jjjj = jjjj + 1;
}
byte Key() { // проверяем кнопки шилда
  if (analogRead(0) < 50) return 3; // вправо
  else if (analogRead(0) < 180) return 2; //вверх
  else if (analogRead(0) < 380) return 4;// вниз
  else if (analogRead(0) < 550) return 1; // влево
  else if (analogRead(0) < 850) return 5; //sekect
  else if (analogRead(0) <= 1100) return 0;
}

void setup() {
  //   virtuino.DEBUG=true;
  //  //bluetoothSerial3.begin(9600);
  //
  //  virtuino.vPinMode(0, INPUT);
  //  virtuino.vPinMode(1, INPUT);
  //  virtuino.vPinMode(2, INPUT);
  // // virtuino.vPinMode(3, INPUT);
  //  virtuino.vPinMode(4, INPUT);
  //  virtuino.vPinMode(5, INPUT);
  //  virtuino.vPinMode(6, INPUT);
  //  //virtuino.vPinMode(7, INPUT);
  Serial.begin(9600);
  Serial1.begin(9600);
  Serial2.begin(9600);
  Serial3.begin(9600);//управление током

  Wire.begin();   // инициируем подключение к шине I2C в качестве ведущего (master) устройства
  kolDatch();
  toch ();
  otpravNaRasch();
  readSet();  // читаем настройки из еепром
  delay (100);
  lcd.begin(20, 4);  // включаем экран
  lcd.clear();       // очищаем экран
  EEPROM.get (35, stat);
  if (stat >= 1 ) {
    Key();
    do {
      lcd.setCursor(0, 0);
      lcd.print(L"Ц");
      lcd.print (tempSen0, 1);  // показываем температуру с датчика царги
      lcd.print (" ");
      lcd.setCursor(7, 0);
      lcd.print(L"Д");
      lcd.print (tempSen1, 1);  // показываем температуру с датчика дефа
      lcd.print (" ");
      lcd.setCursor(14, 0);
      lcd.print(L"К");
      lcd.print (tempSen2, 1);  // показываем температуру с датчика куба
      lcd.print (" ");

      lcd.setCursor(0, 1);
      lcd.print("V:");
      lcd.print (vestelo_eepro);
      lcd.print("mL");
      lcd.setCursor(15, 1);
      if ((time3 / 60 / 60) % 60 < 10) lcd.print ("0");
      lcd.print (time3 / 60 / 60); // час
      lcd.setCursor(17, 1);
      lcd.print (":");
      lcd.setCursor(18, 1);
      if (time3 / 60 % 60 < 10) lcd.print ("0");
      lcd.print ((time3 / 60) % 60);

      lcd.setCursor(0, 2);
      unsigned long time2 = millis() / 1000;
      if (time2 % 2 == 1) {
        lcd.print(L"Otkl: ");
        if (stat == 2) {
          lcd.print (L"t деф > ");
          lcd.print (Max_t_Def);
          lcd.print ("C");
        }
        if (stat == 3) {
          lcd.print (L"t куб > ");
          lcd.print (Max_t_kyb);// необходимо прописать температуру куба
          lcd.print ("C");
        }
        if (stat == 6) {
          lcd.print (L"t царги > ");
          lcd.print (Max_t_Carga);// необходимо прописать температуру куба
          lcd.print ("C");
        }
        if (stat == 8) lcd.print (L"прев ток");
        if (stat == 4) lcd.print (L"вес макс");
        if (stat == 5) lcd.print (L"OTKL DAT t");
      }
      else lcd.print ("                    ");
      lcd.setCursor(0, 3);
      lcd.print (L"нажми лево ");
      lcd.print (total_W_eeprom / 1000.00, 2);
      lcd.print (L"kWt");

    } while (Key() == 0);
    stat = 0;
    EEPROM.put(35, stat);
  }
  else {
    lcd.setCursor(3, 0);
    lcd.print (L"BEPCИЯ MEGA 15");
    lcd.setCursor(3, 1);
    lcd.print (L"ДATЧ t = ");
    lcd.print (kol);

    lcd.setCursor(3, 2);
    lcd.print("email: ");
    lcd.setCursor(2, 3);
    lcd.print("435508@gmail.com");
    delay (4000);
  }
  lcd.clear();       // очищаем экран
  pinMode(YZO, OUTPUT);// активируем выход пина реле
  pinMode(YZOY, OUTPUT);// активируем выход пина реле
  pinMode(ObcheeRele, OUTPUT);// активируем выход пина реле
  pinMode(Relay, OUTPUT);// активируем выход пина реле
  pinMode(Zumer, OUTPUT);// активируем выход пина пищалки
  digitalWrite(YZO, LOW);  // пин пока выключен
  digitalWrite(YZOY, LOW);  // пин пока выключен
  digitalWrite(ObcheeRele, LOW);  // пин пока выключен
  digitalWrite(Relay, LOW);  // пин пока выключен
  digitalWrite(Zumer, LOW);  // пин пока выключен

  scale.set_scale(292.50); // Устанавливаем для весов калибровочный коэффициент//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  readSet();  // читаем настройки из еепром
}

void loop() {
  //    virtuino.run();

  //проверка клавиатуры
  //      Serial.println(Key());
  //      Serial.println(analogRead(0));
  //   //  Serial.println(tok);
  //      Serial.println("");

  Key();//убираем дребезг кнопок
  if (Key() == 1 || Key() == 3 || Key() == 5) {
    if (millis() - previousMillis >= 350) {
      previousMillis = millis();
      KEY = Key();
      button += 1;
    }
    else KEY = 0;
  }
  if (Key() == 2 || Key() == 4) {
    if (millis() - previousMillis >= Tamer_Kei) {
      previousMillis = millis();
      KEY = Key();
      button += 1;
    }
    else KEY = 0;
    if (button > 40) Tamer_Kei = 30;
    else if (button > 10) Tamer_Kei = 170;// фключаем флаг долгого нажатия
  }
  if (Key() == 0) {
    previousMillis = 0;
    KEY = 0;//
    button = 0;
    Tamer_Kei = 350;
  }
  if (KEY != 0 && beepOtkl_knopk == 1) tone(Zumer, 2300, 10);
  readSet();  // читаем настройки из еепром

  realI  = I2C2.readByte(0x02, 3) << 8;   // Считываем старший байт значения потенциометра ведомого (адрес ведомого 0x02, номер регистра 1), сдвигаем полученный байт на 8 бит влево, т.к. он старший
  realI += I2C2.readByte(0x02, 4);        // Считываем младший байт значения потенциометра ведомого (адрес ведомого 0x02, номер регистра 2), добавляя его значение к ранее полученному старшему байту
  symmasymma = I2C2.readByte(0x02, 5);
  symma = round( realI / 20 );
  if (symma == symmasymma) WWW = realI;

  int tok_nano;
  float ii;
  if ( WtOtbor >= 4510) tok_nano = 4510;
  else if (soprotivlenie != 0 && WtOtbor < 4510 ) {
    ii = sqrt (tok / soprotivlenie);
    tok_nano = round (ii * 220);
  }
  else   tok_nano = tok;
  REG_Massive[1]    = tok_nano >> 8;         // Сохраняем старший байт значения потенциометра в  1 ячейку массива REG_Massive
  REG_Massive[2]    = tok_nano;              // Сохраняем младший байт значения потенциометра во 2 ячейку массива REG_Massive
  REG_Massive[3] = round( tok_nano / 20 );
  I2C2.writeByte(0x02, 6, REG_Massive[3]);//контр сумма
  I2C2.writeByte(0x02, 2,  REG_Massive[2]);
  I2C2.writeByte(0x02, 1, REG_Massive[1]);         // Отправляем состояние собственной кнопки ведомому (адрес ведомого 0x02, номер регистра 0, состояние кнопки)

  if (WWW_time < 30) {// среднее значение мощности для экрана
    WWW_symma = WWW_symma + WWW;
    WWW_time = WWW_time + 1;
  }
  if (WWW_time == 30) {
    float toks;
    WWW_time = 0;
    toks = (WWW_symma / 6600.00); // делим на 220 и делим на 30 измерений, итого делим на 6600
    if (soprotivlenie != 0 && WtOtbor < 4510) fakt_I = round (toks * toks * soprotivlenie);
    else fakt_I = (WWW_symma / 30);// получаем среднее значение из 30
    otpravNaRasch(); // сразу отправляем на новый расчет температуры
    WWW_symma = 0;
  }
  //    Serial.print("tok_nano ");
  //    Serial.println(tok_nano);
  //    Serial.print("realI  ");
  //    Serial.println(realI);
  //  // Serial.print("/");//
  //    Serial.print("symma ");
  //        Serial.println(symma);
  //            Serial.print("symmasymma ");
  //        Serial.println(symmasymma);
  //                    Serial.print("WWW ");
  //        Serial.println(WWW);
  //                            Serial.print("WWW_symma ");
  //        Serial.println(WWW_symma);
  //                            Serial.print("WWW_time ");
  //        Serial.println(WWW_time);
  //        Serial.println(" ");//
  if (millis() - work_timer_buffer >= 1000)  // расчет потребления тока за весь процесс
  {
    work_timer_buffer = millis();
    total_W = total_W + (fakt_I / 3600.000);
  }

  //работаем с весами
  if (vestelo > 0) {
    if (millis() - vesMillis >= 2000 ) {
      vesMillis = millis();
      if (Key() == 0) {
        scale.power_up();                              // Отключаем энергосберегающий режим hx711
        vesves = scale.get_units(2) ;           // Запоминаем текущий вес///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        scale.power_down();
        //      Serial.println("vesves");
        //      Serial.println(vesves);
        //      Serial.println("");//
      }
      if (Obiem < 0 && KEY == 0) Trev_ves ++;//для тревоги по избыточному весу, тревога через 10 секунд
      else Trev_ves = 0;
    }
    // if (vesves < 0) vesves = 0.00;
    Obiem = (vestelo - round(vesves)) / 0.80; // переводим вес в объем  жидкости в мл.
    ves_Raznica = vestelo - round(vesves);
  }
  // if (vestelo == 0) Obiem = 0;
  //работаем с температурой
  // kolDatch();//кол-во датчиков температуры
  if (ds.read_bit()) // если расчет температуры закончен, то начинаем считывать
  {
    for (byte i = 0; i < kol; i++) tempa (i);
    // otpravNaRasch(); // сразу отправляем на новый расчет
  }

  if (tempSensor[1] < 0) tempSensor[1] = 0;
  if (tempSensor[0] <= 0 || tempSensor[2] <= 0) {// включим флаг тревоги если не работает датчик температуры
    if (tempSensor[0] < 0) tempSensor[0] = 0;
    if (tempSensor[2] < 0) tempSensor[2] = 0;
    if (millis() - otsutDatT >= 5000) {//флаг тревоги включится через 5 секунд // включение тревоги при потере датчиков
      otsutDatT = millis();
      Koef_Sen_Off += 1;
      if (Koef_Sen_Off >= 2) {
        if (tempSensor[2] == 0) TSensorOff = 3;
        else if (tempSensor[0] == 0) TSensorOff = 2;
        else if (tempSensor[1] == 0 && kol == 3) TSensorOff = 1;
      }
    }
  }
  else {
    TSensorOff = 0;
    Koef_Sen_Off = 0;
  }
  // режимы тревоги
  if (Key() == 0) {
    if (realI >= tok + 500 ) { //тревога по превышению мощности
      if (millis() - trev_Tok >= 10000) {//флаг тревоги включится через 10 секунд
        trev_Tok = millis();
        Trevoga_tok ++;
        if (Trevoga_tok >= 3) {
          stat = 8;//
          //  EEPROM.put(35, stat);
          Trevoga_tok = 3;
        }
      }
    }
    else  if (tempSensor[1] >= Max_t_Def && t_Def_poddershka == 1) {//статус тревоги при превышении t дефа
      if (millis() - trev_temp >= 2000) {//флаг тревоги включится через 5 секунд
        trev_temp = millis();
        koef ++;
        if (koef >= 2) {
          stat = 2;//
          //  EEPROM.put(35, stat);
          koef = 2;
        }
      }
    }
    else if (tempSensor[2] >= Max_t_kyb && t_kyb_poddershka == 1 ) {//статус тревоги при превышении t куба
      if (millis() - trev_temp >= 2000) {//флаг тревоги включится через 5 секунд
        trev_temp = millis();
        koef ++;
        if (koef >= 2) {
          stat = 3;//
          //  EEPROM.put(35, stat);
          koef = 2;
        }
      }
    }
    else  if (tempSensor[0] >= Max_t_Carga && t_Carga_poddershka == 1 ) {//статус тревоги при превышении t дефа
      if (millis() - trev_temp >= 2000) {//флаг тревоги включится через 5 секунд
        trev_temp = millis();
        koef ++;
        if (koef >= 2) {
          stat = 6;//
          // EEPROM.put(35, stat);
          koef = 2;
        }
      }
    }
    else if (Trev_ves > 10) {
      stat = 4;//статус тревоги при превышении веса (сработает через 10 сек)
      //  EEPROM.put(35, stat);
    }
    else if (TSensorOff >= 3 && rezshim == 1) {
      stat = 5; // тревога при отборе сырца
      //  EEPROM.put(35, stat);
    }
    else if (TSensorOff >= 1 && rezshim == 0) {
      stat = 5;//тревога при отборе тела
      //  EEPROM.put(35, stat);
    }
    else if (TSensorOff >= 1 && rezshim == 2) {
      stat = 5;//тревога при ректификации
      //  EEPROM.put(35, stat);
    }
    else {
      if ( stat != 0) {
        stat = 0;
        EEPROM.put(35, stat);
      }
      koef = 0;
      pip = 0;
      Trevoga_tok = 0;
    }
  }
  else {
    if ( stat != 0) {
      stat = 0;
      EEPROM.put(35, stat);
    }
    shetchik = 0;
    koef = 0;
    pip = 0;
    Trevoga_tok = 0;
    TSensorOff = 0;
    Koef_Sen_Off = 0;
  }

  if (stat > 1 ) {//работа при аварийном режиме
    if (millis() - TimeTrevoga >= 1000) {//работа пищалки в прерывистом режиме
      TimeTrevoga = millis();
      shetchik ++;
      if (beepOtkl == 1 && shetchik == 3) {
        tone(Zumer, 2000, 1000); // включаем пищалку
        shetchik = 0;
      }
      pip ++;//расчет когда блок сам отключится
    }

    if (pip >= 1) {
      if (rezshim == 2) digitalWrite(Relay, LOW); // в режиме рект останов отбор
      else digitalWrite(Relay, HIGH);//в остальных режимах вкл воду
      if (pip >= 12 && stat == 8 ) Otkl();  // через 3*4=12 сек откл из-за превышения мощности
      if (pip >= 12 && stat == 2 ) Otkl(); //превышение t дефа
      if (pip >= 12 && stat == 3 ) Otkl(); // превышение t куба
      if (pip >= 12 && stat == 6 ) Otkl(); // превышение t царги
      if (pip >= 20 && stat == 5)  Otkl();  // отключение или потеря датчика t
      if (pip >= 20 && stat == 4) Otkl(); //если превышен вес, то через 30 сек отключить)
    }

  }
  //          Serial.print("pip=    ");
  //        Serial.println(pip);
  //        Serial.print("stat=    ");
  //        Serial.println(stat);
  //        Serial.println("");
  //              Serial.println(jjjj);
  //        Serial.println("");// отключаем весы

  //_________________________________________________________________________________________________
  if (rezshim == 0) {// режим отбора тела/голов

    if (TSensorOff > 0 || tempSensor[0] >= Razg_t_Carga || tempSensor[2] >= Razg_t_kyb ||  tempSensor[1] >= Razg_t_Def) { //режим отбора тела/голов
      digitalWrite(ObcheeRele, HIGH);// включаем подачу воды
      if (tempSensor[0] >= Max_t_Carga && t_Carga_poddershka == 0 ) { //уменьшение мощности тэна при превышен предельн темп
        e = 1 - (tempSensor[0] - Max_t_Carga);
        if (e <= 0)  tok = 0;
        else  tok = round(WtOtbor * e);
      }
      else if ( tempSensor[2] >= Max_t_kyb && t_kyb_poddershka == 0 ) {
        e = 1 - (tempSensor[2] - Max_t_kyb);
        if (e <= 0)  tok = 0;
        else  tok = round(WtOtbor * e);
      }
      else if ( tempSensor[1] >= Max_t_Def && t_Def_poddershka == 0) {
        e = 1 - (tempSensor[1] - Max_t_Def);
        if (e <= 0)  tok = 0;
        else  tok = round(WtOtbor * e);
      }
      else  {
        tok = WtOtbor;
      }
      stat_razgon = 0;// снимим флаг режима не разгон
    }
    else {// режим разгона
      digitalWrite(ObcheeRele, LOW);
      tok = Wtrazgon;
      stat_razgon = 1;// флаг режима разгон
    }
    // управляем реле подачи воды в дэф

    if (tempSensor[0] >= tempDelta || stat > 0)digitalWrite(Relay, HIGH);
    if ( tempSensor[0] < tempDelta && stat == 0) digitalWrite(Relay, LOW);
  }
  //________________________________________________________________________________________________
  if (rezshim == 1) {// режим отбора сырца
    if (tempSensor[0] >= Max_t_Carga && t_Carga_poddershka == 0) { //
      e = 1 - (tempSensor[0] - Max_t_Carga);
      if (e <= 0)  tok = 0;
      else  tok = round(Wtrazgon * e);
    }
    else if ( tempSensor[2] >= Max_t_kyb && t_kyb_poddershka == 0) {
      e = 1 - (tempSensor[2] - Max_t_kyb);
      if (e <= 0)  tok = 0;
      else  tok = round(Wtrazgon * e);
    }
    else if ( tempSensor[1] >= Max_t_Def && t_Def_poddershka == 0) {
      e = 1 - (tempSensor[1] - Max_t_Def);
      if (e <= 0)  tok = 0;
      else  tok = round(Wtrazgon * e);
    }
    else if (Trev_ves > 10) tok = 0;//мощность на 0 если превышен вес
    else  tok = Wtrazgon;
    stat_razgon = 0;// снимим флаг режима разгон

    if (tempSensor[0] >= Razg_t_Carga  || (tempSensor[1] >= Razg_t_Def && tempSensor[1] != 0) || tempSensor[2] >= Razg_t_kyb) digitalWrite(ObcheeRele, HIGH); //режим отбора сырец
    else      digitalWrite(ObcheeRele, LOW);

    if (tempSensor[0] >= tempDelta || stat > 0)digitalWrite(Relay, HIGH);
    if ( tempSensor[0] < tempDelta && stat == 0) digitalWrite(Relay, LOW);

  }
  //________________________________________________________________________________________________
  if (rezshim == 2) {// режим отбора ректификат

    if (TSensorOff > 0 || tempSensor[0] >= Razg_t_Carga  || tempSensor[1] >= Razg_t_Def || tempSensor[2] >= Razg_t_kyb  ) {
      digitalWrite(ObcheeRele, HIGH); //режим отбора сырец
      if (tempSensor[0] >= Max_t_Carga && t_Carga_poddershka == 0) { //уменьшение мощности тэна при превышен предельн темп
        e = 1 - (tempSensor[0] - Max_t_Carga);
        if (e <= 0)  tok = 0;
        else  tok = round( WtOtbor * e);
      }
      else if ( tempSensor[2] >= Max_t_kyb && t_kyb_poddershka == 0 ) {
        e = 1 - (tempSensor[2] - Max_t_kyb);
        if (e <= 0)  tok = 0;
        else  tok = round(WtOtbor * e);
      }
      else if ( tempSensor[1] >= Max_t_Def && t_Def_poddershka == 0) {
        e = 1 - (tempSensor[1] - Max_t_Def);
        if (e <= 0)  tok = 0;
        else  tok = round(WtOtbor * e);
      }
      else  tok = WtOtbor;
      stat_razgon = 0;// снимим флаг режима не разгон
      if (tempSensor[0] >= tempDelta || stat > 0 )digitalWrite(Relay, LOW);
      else {
        if (klapan == 0) {//работа клапана
          if (millis() - Otkrit_Millis >= (klapan_Otkrit * 100) ) { // клапан открыт
            Otkrit_Millis = millis();
            digitalWrite(Relay, HIGH);
            klapan = 1;
          }
        }
        if (klapan == 1) {
          if (millis() - Otkrit_Millis >= (klapan_Zakrit * 100)) { // клапан закрыт
            Otkrit_Millis = millis();
            digitalWrite(Relay, LOW);
            klapan = 0;
          }
        }
      }
    }
    else {//режим разгона
      tok = Wtrazgon;
      stat_razgon = 1;
      digitalWrite(ObcheeRele, LOW);
      digitalWrite(Relay, LOW);

    }
  }

  if (millis() - serial_Time >= 5000) {
    serial_Time = millis();
    //  Grafik();//передадим через serial значения для графиков
    Blupyp();//передаем значения для блютуза
  }
  //    Serial.print("tok=");
  //  Serial.println(tok);
  //  Serial.print("fakt_I=");
  //  Serial.println(fakt_I);
  //
  //  Serial.print("stat=    ");
  //  Serial.println(stat);
  //  Serial.println("");// отключаем весы
  if (menuLevel == 0)
  {
    lcd.setCursor(0, 0);
    lcd.print(L"Ц");
    lcd.print (tempSensor[0], 1);  // показываем температуру с датчика царги
    lcd.print (" ");
    lcd.setCursor(7, 0);
    lcd.print(L"Д");
    lcd.print (tempSensor[1], 1);  // показываем температуру с датчика дефа
    lcd.print (" ");
    lcd.setCursor(14, 0);
    lcd.print(L"К");
    lcd.print (tempSensor[2], 1);  // показываем температуру с датчика куба
    lcd.print (" ");
    lcd.setCursor(0, 1);
    lcd.print(L"ц");
    lcd.print(tempDelta, 1); // показываем установленную температуру дельты
    lcd.print (" ");
    lcd.setCursor(7, 1);
    //    if ( WtOtbor >= 3510)    lcd.print ("indukt");
    //    else {
    lcd.print ("W:");
    lcd.print (fakt_I);
    lcd.print ("  ");
    //   }
    unsigned long time = millis() / 1000;
    lcd.setCursor(15, 1);
    if ((time / 60 / 60) % 60 < 10) lcd.print ("0");
    lcd.print (time / 60 / 60); // час
    lcd.setCursor(17, 1);
    if (time % 2 == 1)  lcd.print (":");
    else   lcd.print (" ");
    lcd.setCursor(18, 1);
    if (time / 60 % 60 < 10) lcd.print ("0");
    lcd.print ((time / 60) % 60);

    lcd.setCursor(0, 2);
    lcd.print("V:");
    if (vestelo <= 0) lcd.print("OTKL");
    else {
      lcd.print (Obiem);
      lcd.print("mL   ");
    }



    lcd.setCursor(0, 3);
    //////////////////////////////////////////////////////////////////
    // для отслеживания ошибок
    if (stat > 1) stat_KVO = stat;
    if (Key() != 0) stat_KVO = 0;

    if (stat_KVO == 0) {
      if (tempSensor[0] >= Max_t_Carga) {
        lcd.print (L"t цар>");
        lcd.print (Max_t_Carga);
        lcd.print (L"  ");
      }
      else if (tempSensor[1] >= Max_t_Def) {
        lcd.print (L"t деф>");
        lcd.print (Max_t_Def);
        lcd.print (L"  ");
      }
      else if (tempSensor[2] >= Max_t_kyb) {
        lcd.print (L"t куб>");
        lcd.print (Max_t_kyb);
        lcd.print (L"  ");
      }
      else if (rezshim == 0 ) {
        lcd.print(L"ТЕЛО       ");
      }
      else if ( rezshim == 1 ) {
        lcd.print(L"СblРЕЦ     ");
      }
      else if (rezshim == 2 ) {
        lcd.print(L"PEKT       ");
      }
      else  lcd.print(L"           ");
    }
    if (stat_KVO >= 1) { //если режим тревоги то моргаем надписью

      if (pip >= 12 && stat == 8 ) Otkl();  // через 3*4=12 сек откл из-за превышения мощности
      if (pip >= 12 && stat == 2 ) Otkl(); //превышение t дефа
      if (pip >= 12 && stat == 3 ) Otkl(); // превышение t куба
      if (pip >= 12 && stat == 6 ) Otkl(); // превышение t царги
      if (pip >= 20 && stat == 5)  Otkl();  // отключение или потеря датчика t
      if (pip >= 20 && stat == 4) Otkl(); //если превышен вес, то через 30 сек отключить)

      if (time % 2 == 1) {
        if (stat_KVO == 8) lcd.print (L"прев мощ");
        if (stat_KVO == 2) {
          lcd.print (L"t Д>");
          lcd.print (Max_t_Def);
          lcd.print (L"  ");
        }
        if (stat_KVO == 3) {
          lcd.print (L"t К>");
          lcd.print (Max_t_kyb);// необходимо прописать температуру куба______________________________________
          lcd.print (L"  ");
        }
        if (stat_KVO == 6) {
          lcd.print (L"t Ц>");
          lcd.print (Max_t_Carga);// необходимо прописать температуру куба______________________________________
          lcd.print (L"  ");
        }
        if (stat_KVO == 4) lcd.print (L"вес");
        if (stat_KVO == 5) lcd.print (L"DAT t");

      }

      else   lcd.print ("        ");
      lcd.setCursor(8, 3);
      lcd.print (L"(");
      lcd.print (pip);
      lcd.print (L")");
    }
    //        if (stat == 0) {
    //      if (tempSensor[0] >= Max_t_Carga) {
    //        lcd.print (L"t цар>");
    //        lcd.print (Max_t_Carga);
    //        lcd.print (L"  ");
    //      }
    //      else if (tempSensor[1] >= Max_t_Def) {
    //        lcd.print (L"t деф>");
    //        lcd.print (Max_t_Def);
    //        lcd.print (L"  ");
    //      }
    //      else if (tempSensor[2] >= Max_t_kyb) {
    //        lcd.print (L"t куб>");
    //        lcd.print (Max_t_kyb);
    //        lcd.print (L"  ");
    //      }
    //
    //      else if (rezshim == 0 ) {
    //        lcd.print(L"ТЕЛО       ");
    //      }
    //      else if ( rezshim == 1 ) {
    //        lcd.print(L"СblРЕЦ     ");
    //      }
    //      else if (rezshim == 2 ) {
    //        lcd.print(L"PEKT       ");
    //      }
    //      else  lcd.print(L"           ");
    //    }
    //    if (stat >= 1) { //если режим тревоги то моргаем надписью
    //      if (time % 2 == 1) {
    //        if (stat == 1) lcd.print (L"превыш мощ");
    //        if (stat == 2) {
    //          lcd.print (L"t деф>");
    //          lcd.print (Max_t_Def);
    //          lcd.print (L"  ");
    //        }
    //        if (stat == 3) {
    //          lcd.print (L"t куб>");
    //          lcd.print (Max_t_kyb);// необходимо прописать температуру куба______________________________________
    //          lcd.print (L"  ");
    //        }
    //        if (stat == 6) {
    //          lcd.print (L"t цар>");
    //          lcd.print (Max_t_Carga);// необходимо прописать температуру куба______________________________________
    //          lcd.print (L"  ");
    //        }
    //        if (stat == 4) lcd.print (L"проверь вес");
    //        if (stat == 5) lcd.print (L"OTKL DAT t");
    //        if (stat == 7) lcd.print (L"проверь тен");
    //      }
    //      else   lcd.print ("           ");
    //    }

    lcd.setCursor(13, 2);
    if (stat_razgon == 1) lcd.print (L"Разгон ");
    else {
      if (digitalRead(Relay) == HIGH) lcd.print(L"Кл1 ");
      else lcd.print ("    ");
      lcd.setCursor(17, 2);
      if (digitalRead(ObcheeRele) == HIGH) lcd.print(L"Кл2");
      else lcd.print ("   ");
    }
    lcd.setCursor(13, 3);
    lcd.print ("HACTP->");

    if (KEY == 4) { // если нажата кнопка
      tempDelta -= 0.1; // изменяем значение
      if (tempDelta < 0) tempDelta = 0;
      EEPROM.put(0, tempDelta); // сохраняем в еепром
    }

    if (KEY == 2) {
      tempDelta += 0.1; // изменяем значение
      if (tempDelta > 110) tempDelta = 110;
      EEPROM.put(0, tempDelta);
    }

    if (KEY == 3) { //  шагаем следующее меню
      menuLevel = 1;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 5) { //  шагаем следующее меню
      menuLevel = 10;
      lcd.clear();
      KEY = 0;
    }
  }

  if (menuLevel == 1)// задаем значение для весов
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Ycтaнoвka вecoв");
    lcd.setCursor(1, 1); // установим таймер времени
    lcd.print (L"Отобрать:");
    lcd.setCursor(11, 1);
    if (vestelo <= 0) lcd.print (L"OTKL    ");
    else {
      lcd.print (Obiem);
      lcd.print (L" ml ");
    }

    lcd.setCursor(1, 2);
    lcd.print (L"Отобрать:");
    lcd.setCursor(11, 2);
    if (vestelo <= 0) lcd.print (L"OTKL    ");
    else {
      lcd.print (ves_Raznica);
      lcd.print (L" gr ");
    }
    lcd.setCursor(1, 3);
    lcd.print (L"вec весы:"); // показываем температуру с датчика царги
    lcd.setCursor(11, 3);
    lcd.print (round(vesves));  // показываем температуру с датчика дефа///////////////////////////////////////////////////////////////////////
    lcd.print (L" gr ");



    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {////////////////////////////////////////////////////////////////////////////////////////////
      if (i == Ekran && i != 0) {
        unsigned long time2 = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time2 % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");

      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0) {

        lcd.setCursor(10, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 2) Ekran = 2;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 10;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 10) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 10;//прыгаем по столбцам
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 10 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran >= 1 && Pezhim_ekran == 10) { // если нажата кнопка
      vestelo -= 10; // изменяем значение
      if (vestelo < 0) vestelo = 0;
      EEPROM.put(5, vestelo); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran >= 1 && Pezhim_ekran == 10) {
      vestelo += 10; // изменяем значение
      if (vestelo > 20000) vestelo = 20000;
      EEPROM.put(5, vestelo); // сохраняем в еепром
    }

    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 2;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 0;
      lcd.clear();
      KEY = 0;
    }

  }
  if (menuLevel == 2)// задаем мощность тена
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Уcтaн тeн");

    lcd.setCursor(1, 1); // установим таймер времени
    lcd.print (L"Отбор  ток:");  // показываем температуру с датчика царги
    lcd.setCursor(13, 1);
    if ( WtOtbor >= 4510)    lcd.print ("indukt");
    else {
      lcd.print (WtOtbor);  // показываем температуру с датчика дефа
      lcd.print ("Wt ");
    }
    lcd.setCursor(1, 2); // установим таймер времени
    lcd.print (L"Paзгон ток:");  // показываем температуру с датчика царги
    lcd.setCursor(13, 2);
    if ( WtOtbor >= 4510)    lcd.print ("induk");
    else {
      lcd.print (Wtrazgon);  // показываем температуру с датчика дефа
      lcd.print ("Wt ");
    }

    lcd.setCursor(1, 3);
    lcd.print (L"Pacxoд kWt:");   // показываем температуру с датчика царги
    lcd.setCursor(13, 3);
    lcd.print (total_W / 1000.00, 2); // показываем температуру с датчика дефа
    lcd.print (" ");

    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        unsigned long time2 = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time2 % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");

      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0) {
        lcd.setCursor(12, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 2) Ekran = 2;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 12;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 12) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 12;
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 12 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 12 ) { // если нажата кнопка
      WtOtbor -= 10; // изменяем значение
      if (WtOtbor < 100) WtOtbor = 100;
      EEPROM.put(15, WtOtbor); // сохраняем в еепром
    }
    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 12) {
      WtOtbor += 10; // изменяем значение
      if (WtOtbor > 4510) WtOtbor = 4510;
      EEPROM.put(15, WtOtbor); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 12) { // если нажата кнопка2
      Wtrazgon -= 10; // изменяем значение
      if (Wtrazgon < 100) Wtrazgon = 100;
      EEPROM.put(10, Wtrazgon); // сохраняем в еепром
    }
    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 12) {
      Wtrazgon += 10; // изменяем значение
      if (Wtrazgon > 4500) Wtrazgon = 4500;
      EEPROM.put(10, Wtrazgon); // сохраняем в еепром
    }

    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 3;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 1;
      lcd.clear();
      KEY = 0;
    }
  }

  if (menuLevel == 3)// задаем максимальную мощность тена
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Уcтaн max t   otkl");
    lcd.setCursor(1, 1);
    lcd.print (L"max t kyбa:");
    lcd.setCursor(13, 1);
    lcd.print (Max_t_kyb);  // показываем температуру с датчика дефа
    lcd.print ("C ");
    lcd.setCursor(18, 1);
    if (t_kyb_poddershka == 1)  lcd.print (L"да");
    else lcd.print (L"не");
    lcd.setCursor(1, 2);
    lcd.print (L"max t дeфa:");
    lcd.setCursor(13, 2);
    lcd.print (Max_t_Def);  // показываем температуру с датчика дефа
    lcd.print ("C ");
    lcd.setCursor(18, 2);
    if (t_Def_poddershka == 1)  lcd.print (L"да");
    else lcd.print (L"не");
    lcd.setCursor(1, 3);
    lcd.print (L"max t царг:");
    lcd.setCursor(13, 3);
    lcd.print (Max_t_Carga);  // показываем температуру с датчика дефа
    lcd.print ("C ");
    lcd.setCursor(18, 3);
    if (t_Carga_poddershka == 1)  lcd.print (L"да");
    else lcd.print (L"не");
    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }
    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        unsigned long time2 = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time2 % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");
      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      //      if (Pezhim_ekran == 0 && i != 0) {
      //        lcd.setCursor(12, i);
      //        lcd.print (" ");
      //        lcd.setCursor(17, i);
      //        lcd.print (" ");
      //      }
    }
    //перемещаем вверх и вниз
    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 3) Ekran = 3;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    //перемещаем по строчке кнопкой сет
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 12;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 12) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    //перемещаем впрово влево
    if (KEY == 3 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 12;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 && Pezhim_ekran == 12 ) {
      Pezhim_ekran = 17;
      KEY = 0;
      lcd.setCursor(12, Ekran);
      lcd.print (" ");
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 17) {
      Pezhim_ekran = 12 ;
      KEY = 0;
      lcd.setCursor(17, Ekran);
      lcd.print (" ");
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 12) {
      Pezhim_ekran = 0 ;
      KEY = 0;
      lcd.setCursor(12, Ekran);
      lcd.print (" ");
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 17) { // если нажата кнопка
      t_kyb_poddershka = 0; // изменяем значение
      EEPROM.put(75, t_kyb_poddershka); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 17) {
      t_kyb_poddershka = 1; // изменяем значение
      EEPROM.put(75, t_kyb_poddershka); // сохраняем в еепром
    }


    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 12) { // если нажата кнопка
      Max_t_kyb -= 1; // изменяем значение
      if (Max_t_kyb < 0) Max_t_kyb = 120;
      EEPROM.put(20, Max_t_kyb); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 12) {
      Max_t_kyb += 1; // изменяем значение
      if (Max_t_kyb > 120) Max_t_kyb = 0;
      EEPROM.put(20, Max_t_kyb); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 17) { // если нажата кнопка
      t_Def_poddershka = 0; // изменяем значение
      EEPROM.put(80, t_Def_poddershka); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 17) {
      t_Def_poddershka = 1; // изменяем значение
      EEPROM.put(80, t_Def_poddershka); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 12) { // если нажата кнопка
      Max_t_Def -= 1; // изменяем значение
      if (Max_t_Def < 0) Max_t_Def = 120;
      EEPROM.put(25, Max_t_Def); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 12) {
      Max_t_Def += 1; // изменяем значение
      if (Max_t_Def > 120) Max_t_Def = 0;
      EEPROM.put(25, Max_t_Def); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 3 && Pezhim_ekran == 17) { // если нажата кнопка
      t_Carga_poddershka = 0; // изменяем значение
      EEPROM.put(85, t_Carga_poddershka); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 3 && Pezhim_ekran == 17) {
      t_Carga_poddershka = 1; // изменяем значение
      EEPROM.put(85, t_Carga_poddershka); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 3 && Pezhim_ekran == 12) { // если нажата кнопка
      Max_t_Carga -= 1; // изменяем значение
      if (Max_t_Carga < 0) Max_t_Carga = 120;
      EEPROM.put(45, Max_t_Carga); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 3 && Pezhim_ekran == 12) {
      Max_t_Carga += 1; // изменяем значение
      if (Max_t_Carga > 120) Max_t_Carga = 0;
      EEPROM.put(45, Max_t_Carga); // сохраняем в еепром
    }
    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 4;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 2;
      lcd.clear();
      KEY = 0;
    }
  }
  if (menuLevel == 4)// задаем до скольки разгонять
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Разгон до");
    lcd.setCursor(1, 1);
    lcd.print (L"    t kyбa:");
    lcd.setCursor(13, 1);
    lcd.print (Razg_t_kyb);  // показываем температуру с датчика дефа
    lcd.print ("C  ");
    lcd.setCursor(1, 2);
    lcd.print (L"    t дeфa:");
    lcd.setCursor(13, 2);
    lcd.print (Razg_t_Def);  // показываем температуру с датчика дефа
    lcd.print ("C  ");
    lcd.setCursor(1, 3);
    lcd.print (L"    t царг:");
    lcd.setCursor(13, 3);
    lcd.print (Razg_t_Carga);  // показываем температуру с датчика дефа
    lcd.print ("C  ");
    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        long time = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");
      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0 && i != 0) {
        lcd.setCursor(12, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 3) Ekran = 3;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 12;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 12) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 12;
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 12 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 12) { // если нажата кнопка
      Razg_t_kyb -= 1; // изменяем значение
      if (Razg_t_kyb < 0) Razg_t_kyb = 120;
      EEPROM.put(50, Razg_t_kyb); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 12) {
      Razg_t_kyb += 1; // изменяем значение
      if (Razg_t_kyb > 120) Razg_t_kyb = 0;
      EEPROM.put(50, Razg_t_kyb); // сохраняем в еепром
    }
    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 12) { // если нажата кнопка
      Razg_t_Def -= 1; // изменяем значение
      if (Razg_t_Def < 0) Razg_t_Def = 120;
      EEPROM.put(55, Razg_t_Def); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 12) {
      Razg_t_Def += 1; // изменяем значение
      if (Razg_t_Def > 120) Razg_t_Def = 0;
      EEPROM.put(55, Razg_t_Def); // сохраняем в еепром
    }
    if (KEY == 4 && Ekran == 3 && Pezhim_ekran == 12) { // если нажата кнопка
      Razg_t_Carga -= 1; // изменяем значение
      if (Razg_t_Carga < 0) Razg_t_Carga = 120;
      EEPROM.put(60, Razg_t_Carga); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 3 && Pezhim_ekran == 12) {
      Razg_t_Carga += 1; // изменяем значение
      if (Razg_t_Carga > 120) Razg_t_Carga = 0;
      EEPROM.put(60, Razg_t_Carga); // сохраняем в еепром
    }
    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 5;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 3;
      lcd.clear();
      KEY = 0;
    }
  }
  if (menuLevel == 5)// //klapan_Otkrit klapan_Zakrit
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Peжим pekт");
    lcd.setCursor(1, 1);
    lcd.print (L"Oтkpыт: ");
    lcd.setCursor(10, 1);
    lcd.print (klapan_Otkrit / 10.0 , 1); // показываем температуру с датчика дефа lcd.print (tempSensor[0], 1);
    lcd.print ("cek ");
    lcd.setCursor(1, 2);
    lcd.print (L"3akpыт: ");
    lcd.setCursor(10, 2);
    lcd.print (klapan_Zakrit / 10.0 , 1); // показываем температуру с датчика дефа
    lcd.print ("cek ");

    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      //      lcd.setCursor(19, 0);
      //      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        long time = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time % 2 == 1)  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");
      }

      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0 && i != 0) {
        lcd.setCursor(9, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 2) Ekran = 2;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 9;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 9) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 9;
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 9 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 9) { // если нажата кнопка
      klapan_Otkrit -= 1; // изменяем значение
      if (klapan_Otkrit < 0) klapan_Otkrit = 0;
      EEPROM.put(65, klapan_Otkrit); // сохраняем в еепром
    }
    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 9) {
      klapan_Otkrit += 1; // изменяем значение
      if (klapan_Otkrit > 1200) klapan_Otkrit = 1200;
      EEPROM.put(65, klapan_Otkrit); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 9 ) { // если нажата кнопка
      klapan_Zakrit -= 1; // изменяем значение
      if (klapan_Zakrit < 0) klapan_Zakrit = 0;
      EEPROM.put(70, klapan_Zakrit); // сохраняем в еепром
    }
    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 9) {
      klapan_Zakrit += 1; // изменяем значение
      if (klapan_Zakrit > 1200) klapan_Zakrit = 1200;
      EEPROM.put(70, klapan_Zakrit); // сохраняем в еепром
    }

    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 6;
      lcd.clear();
      KEY = 0;
    }
    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 4;
      lcd.clear();
      KEY = 0;
    }
  }
  if (menuLevel == 6)// задаем до скольки разгонять
  {
    lcd.setCursor(1, 0);
    lcd.print (L"Звук");

    lcd.setCursor(1, 1);
    lcd.print (L"тревог");
    lcd.setCursor(9, 1);
    if (beepOtkl == 1)  lcd.print (L"да ");
    else lcd.print (L"нет");
    lcd.setCursor(1, 2);
    lcd.print (L"кнопок");
    lcd.setCursor(9, 2);
    if (beepOtkl_knopk == 1)  lcd.print (L"да ");
    else lcd.print (L"нет");

    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        long time = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");
      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0 && i != 0) {
        lcd.setCursor(8, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 2) Ekran = 2;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 8;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 8) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 8;
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 8 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 8) { // если нажата кнопка
      beepOtkl = 0; // изменяем значение
      EEPROM.put(120, beepOtkl); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 8) {
      beepOtkl = 1; // изменяем значение
      EEPROM.put(120, beepOtkl); // сохраняем в еепром
    }
    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 8) { // если нажата кнопка
      beepOtkl_knopk = 0; // изменяем значение
      EEPROM.put(125, beepOtkl_knopk); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 8) {
      beepOtkl_knopk = 1; // изменяем значение
      EEPROM.put(125, beepOtkl_knopk); // сохраняем в еепром
    }
    if (KEY == 3 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 7;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 5;
      lcd.clear();
      KEY = 0;
    }
  }
  if (menuLevel == 7)// задаем до скольки разгонять
  {
    int moch;
    moch = 52900 / soprotivlenie; // p=u*u/r = 230*230/R
    lcd.setCursor(1, 0);
    lcd.print (L"HACTP MOЩHOCTb");

    lcd.setCursor(1, 1);
    lcd.print (L"MOЩHOCTb:");
    lcd.setCursor(11, 1);
    lcd.print (moch);
    lcd.print (L" Bt ");
    lcd.setCursor(1, 2);
    lcd.print (L"COПPOTИB:");
    lcd.setCursor(11, 2);
    lcd.print (soprotivlenie, 1);
    lcd.print (L" Om ");
    if (soprotivlenie == 0) lcd.print (L"  ");

    if (Ekran == 0) {
      lcd.setCursor(0, 0);
      lcd.print ("<");
      lcd.setCursor(19, 0);
      lcd.print (">");
    }
    else {
      lcd.setCursor(0, 0);
      lcd.print (" ");
      lcd.setCursor(19, 0);
      lcd.print (" ");
    }
    if (Ekran == 0 && KEY == 5) {
      Ekran = 1;
      KEY = 0;
    }

    for (byte i = 0; i < 4; i++) {
      if (i == Ekran && i != 0) {
        long time = millis() / 1000;
        lcd.setCursor(Pezhim_ekran, Ekran);
        if (time % 2 == 1 || Key() != 0 )  lcd.print (">");
        else  if (Key() == 0) lcd.print (" ");
      }
      if (i != Ekran ) {
        lcd.setCursor(0, i);
        lcd.print (" ");
      }
      if (Pezhim_ekran == 0 && i != 0) {
        lcd.setCursor(10, i);
        lcd.print (" ");
      }
    }

    if (KEY == 4 && Pezhim_ekran == 0) {
      Ekran += 1;
      if (Ekran >= 2) Ekran = 2;
    }
    if (KEY == 2 && Pezhim_ekran == 0) {
      Ekran -= 1;
      if (Ekran <= 0) Ekran = 0;
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 0 ) {
      Pezhim_ekran = 14;
      KEY = 0;
      lcd.setCursor(0, Ekran);
      lcd.print (">");
    }
    if (KEY == 5 && Ekran > 0 && Pezhim_ekran == 10) {
      Pezhim_ekran = 0 ;
      KEY = 0;
    }
    if (KEY == 3 && Ekran > 0 )Pezhim_ekran = 10;
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 10 ) {
      Pezhim_ekran = 0;
      button = 0;
    }
    if (KEY == 1 && Ekran > 0 && Pezhim_ekran == 0 && button == 3 ) {//при долгом нажатии вправо сразу попадем на главн экран
      menuLevel = 0 ;
      Ekran = 0;
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 4 && Ekran == 1 && Pezhim_ekran == 10) { // если нажата кнопка
      moch -= 50; // изменяем значение
      if (moch <= 0) {
        moch = 0;
        soprotivlenie = 0;
      }
      else soprotivlenie = 52900.0 / moch;
      EEPROM.put(130, soprotivlenie); // сохраняем в еепром
    }

    if (KEY == 2 && Ekran == 1 && Pezhim_ekran == 10) {
      moch += 50; // изменяем значение
      if (moch >= 10000) moch = 10000;
      soprotivlenie = 52900.0 / moch;
      EEPROM.put(130, soprotivlenie); // сохраняем в еепром
    }
    if (KEY == 2 && Ekran == 2 && Pezhim_ekran == 10) { // если нажата кнопка
      moch -= 50; // изменяем значение
      if (moch <= 0) {
        moch = 0;
        soprotivlenie = 0;
      }
      else soprotivlenie = 52900.0 / moch;
      EEPROM.put(130, soprotivlenie); // сохраняем в еепром
    }

    if (KEY == 4 && Ekran == 2 && Pezhim_ekran == 10) {
      moch += 50; // изменяем значение
      if (moch >= 10000) moch = 10000;
      soprotivlenie = 52900.0 / moch;
      EEPROM.put(130, soprotivlenie); // сохраняем в еепром
    }


    if (KEY == 1 && Ekran == 0) { //  шагаем следующее меню
      menuLevel = 6;
      lcd.clear();
      KEY = 0;
    }
  }
  if (menuLevel == 10)// задаем максимальную
  {
    lcd.setCursor(0, 0);
    lcd.print (L"РЕЖИМ РАБОТbl:");
    lcd.setCursor(0, 1);
    if (rezshim == 0 ) lcd.print (">");
    if (rezshim == 1 || rezshim == 2) lcd.print (" ");
    lcd.print (L" ТЕЛО / ГОЛОВbl");
    lcd.setCursor(0, 2);
    if (rezshim == 1) lcd.print (">");
    if (rezshim == 0 || rezshim == 2) lcd.print (" ");
    lcd.print (L" CblРЕЦ / ХВОСТbl");
    lcd.setCursor(0, 3);
    if (rezshim == 2) lcd.print (">");
    if (rezshim == 0 || rezshim == 1 ) lcd.print (" ");
    lcd.print (L" PEKTИФИKAЦИЯ");


    if (KEY == 4) { // если нажата кнопка
      rezshim = rezshim + 1;
      if (rezshim > 2) rezshim = 2;
      EEPROM.put(30, rezshim);
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 2) {
      rezshim = rezshim - 1;
      if (rezshim < 0) rezshim = 0;
      EEPROM.put(30, rezshim);
      lcd.clear();
      KEY = 0;
    }

    if (KEY == 5) { //  шагаем следующее меню
      menuLevel = 0;
      lcd.clear();
      KEY = 0;
    }
  }

}

